<?php
define('BB_SCRIPT', 'top');
define('BB_ROOT', './');
require(BB_ROOT ."common.php");
require(INC_DIR ."functions_top.php");

$page_cfg['use_tablesorter']   = 1;
$page_cfg['include_bbcode_js'] = 1;

$users_per_page = 30;
$total_users = 0;

// Start session management
$user->session_start(array('req_login' => true));

$mode  = isset($_GET['mode']) ? $_GET['mode'] : 'release';
$stat  = isset($_GET['stat']) ? $_GET['stat'] : '';
$start = isset($_GET['start']) ? abs(intval($_GET['start'])) : 0;
$sort_name = isset($_REQUEST['name']) ? mb_strtolower(trim($_REQUEST['name']), 'UTF-8') : '';

$start = floor($start/$users_per_page) * $users_per_page;
$i = 0;
$replies = ${'30days'} = $all = $month = $week = $upload = $download = $bonus = $release = $seedbonus = $ratio = '';

if(!$stat) $stat = 'all';

if($mode == 'release')
{
  if($stat == 'all')			$all = '-all';
  if($stat == 'month')		$month = '-month';
  if($stat == 'week')			$week = '-week';
  if($stat == '30days')		${'30days'} = '-30days';
  if($stat == 'replies')	$replies = '-replies';

 	$template->assign_block_vars('switch_release_top', array());
	$template->assign_vars(array(
	  'PAGE_TITLE'				=> $lang['TOP_RELEASE'],
		'U_TOP'							=> '<a href="'.BB_ROOT.'top.php?mode=release" />'.$lang['TOP_RELEASE'].'</a>',
  	'U_RELEASE_ALL'			=> '<a href="'.BB_ROOT.'top.php?mode=release&stat=all" class="ui-corner-top top-link'.$all.'" title="'.$lang['TOP_RELEASE_ALL'].'">'.$lang['TOP_RELEASE_ALL'].'</a>',
		'U_RELEASE_MONTH'		=> '<a href="'.BB_ROOT.'top.php?mode=release&stat=month" class="ui-corner-top top-link'.$month.'" title="'.$lang['TOP_RELEASE_MONTH'].'">'.$lang['TOP_RELEASE_MONTH'].'</a>',
		'U_RELEASE_WEEK'		=> '<a href="'.BB_ROOT.'top.php?mode=release&stat=week" class="ui-corner-top top-link'.$week.'" title="'.$lang['TOP_RELEASE_WEEK'].'">'.$lang['TOP_RELEASE_WEEK'].'</a>',
		'U_RELEASE_30DAYS'	=> '<a href="'.BB_ROOT.'top.php?mode=release&stat=30days" class="ui-corner-top top-link'.${'30days'}.'" title="'.$lang['TOP_RELEASE_30DAYS'].'">'.$lang['TOP_RELEASE_30DAYS'].'</a>',
		'U_RELEASE_REPLIES'	=> '<a href="'.BB_ROOT.'top.php?mode=release&stat=replies" class="ui-corner-top top-link'.$replies.'" title="'.$lang['TOP_RELEASE_REPLIES'].'">'.$lang['TOP_RELEASE_REPLIES'].'</a>',
	));
	$data = getTopRelease($stat);
	foreach($data as $row)
	{
		$template->assign_block_vars('switch_release_top.release', array(
		  'ROW_CLASS'   => !($i % 2) ? 'row2' : 'row1',
			'FORUM_URL'		=> '<a class="med bold" href="'.FORUM_URL.$row['forum_id'].'" />'.htmlChr($row['forum_name']).'</a>',
			'TOPIC_URL'		=> '<a class="tLink med bold folded2" onclick="ajax.view_post('.$row['topic_id'].', this); return false;" href="'.TOPIC_URL.$row['topic_id'].'" />'.htmlChr($row['topic_title']).'</a>',
			'TOPIC_ID'		=> $row['topic_id'],
			'COMPLETE'		=> $row['complete_count'],
			'REPLIES'			=> $row['topic_replies'],
			'DL_URL'			=> !isset($bb_cfg['tor_frozen'][$row['tor_status']]) ? '<a class="small tr-dl" href="'.DOWNLOAD_URL.$row['attach_id'].'">'.humn_size($row['size']).'&nbsp;&#8595;</a>' : humn_size($row['size']),
			'TBS_SIZE'		=> $row['size'],
			'POSTER_URL'	=> '<a class="med bold" href="'.PROFILE_URL.$row['user_id'].'" />'.$row['username'].'</a>',
			'REG_TIME'		=> bb_date($row['reg_time'], $bb_cfg['default_dateformat']),
			'TBS_TIME'		=> $row['reg_time'],
		));
		$i++;
	}
}
elseif($mode == 'users')
{
  if(!$stat || $stat == 'all') $stat = 'upload';
  if($stat == 'upload')   $upload = '-upload';
  if($stat == 'download') $download = '-download';
  if($stat == 'bonus')  	$bonus = '-bonus';
  if($stat == 'release')  $release = '-release';
  if($stat == 'seedbonus')$seedbonus = '-seedbonus';
  if($stat == 'ratio')  	$ratio = '-ratio';
	$select_letter = array();
	$selected = 0;
	for ($i=ord('A'), $cnt=ord('Z'); $i <= $cnt; $i++)
	{
		$select_letter[$i+32] = chr($i);
	}
	for ($i=224, $cnt=255; $i <= $cnt; $i++)
	{
		$select_letter[$i] = iconv('windows-1251', 'UTF-8', chr($i-32));
	}
	$selected = (ord(iconv('UTF-8', 'windows-1251', $sort_name)));
	if($sort_name != '')
	{
		$cnt = "SELECT COUNT(u.user_id) AS count 
						FROM ".BB_BT_USERS." AS bt
						LEFT JOIN ".BB_USERS." AS u ON(u.username LIKE '".DB()->escape($sort_name)."%' AND u.user_id = bt.user_id)
						WHERE bt.u_down_total > ".MIN_DL_FOR_RATIO;
	}
	else
	{
		$cnt = "SELECT COUNT(user_id) AS count FROM ".BB_BT_USERS."	WHERE u_down_total > ".MIN_DL_FOR_RATIO;
	}
	if($users = DB()->fetch_row($cnt))	$total_users = (int) $users['count'];

	$pg_url = '?mode=users';
	$pg_url .= isset($stat) ? "&amp;stat=$stat" : '';
	$pg_url .= ($sort_name != '') ? "&amp;name=$sort_name" : '';
	
  $pagination = generate_pagination($pg_url, $total_users, $users_per_page, $start);
	$template->assign_block_vars('switch_users_top', array());
	$template->assign_vars(array(
	  'PAGE_TITLE'					=> $lang['TOP_USERS'],
		'U_TOP'								=> '<a href="'.BB_ROOT.'top.php?mode=users" />'.$lang['TOP_RELEASE'].'</a>',
	  'U_TOP_UPLOAD'				=> '<a href="'.BB_ROOT.'top.php?mode=users&stat=upload" class="ui-corner-top top-link'.$upload.'" title="'.$lang['TOP_UPLOAD'].'" />'.$lang['TOP_UPLOAD'].'</a>',
  	'U_TOP_DOWNLOAD'			=> '<a href="'.BB_ROOT.'top.php?mode=users&stat=download" class="ui-corner-top top-link'.$download.'" title="'.$lang['TOP_DOWNLOAD'].'" />'.$lang['TOP_DOWNLOAD'].'</a>',
		'U_TOP_BONUS'					=> '<a href="'.BB_ROOT.'top.php?mode=users&stat=bonus" class="ui-corner-top top-link'.$bonus.'" title="'.$lang['TOP_BONUS'].'" />'.$lang['TOP_BONUS'].'</a>',
		'U_TOP_RELEASES'			=> '<a href="'.BB_ROOT.'top.php?mode=users&stat=release" class="ui-corner-top top-link'.$release.'" title="'.$lang['TOP_RELEASES'].'" />'.$lang['TOP_RELEASES'].'</a>',
		'U_TOP_SEEDBONUS'			=> '<a href="'.BB_ROOT.'top.php?mode=users&stat=seedbonus" class="ui-corner-top top-link'.$seedbonus.'" title="'.$lang['TOP_RELEASES'].'" />'.$lang['TOP_SEEDBONUS'].'</a>',
		'U_TOP_RATIO'         => '<a href="'.BB_ROOT.'top.php?mode=users&stat=ratio" class="ui-corner-top top-link'.$ratio.'" title="'.$lang['TOP_RATIO'].'" />'.$lang['TOP_RATIO'].'</a>',
		'SELECT_LETTER'				=> build_select('select-name', array_flip($select_letter), $selected, null, null, 'style="width: 70px; font-weight:bold;" onChange="_reload(); return false;"'), 
	  'PAGINATION'          => $pagination,
	  'PAGE_NUMBER'         => sprintf($lang['PAGE_OF'], ( floor($start/$users_per_page) + 1 ), ceil( $total_users / $users_per_page )),
	));
	$data = getTopUsers($stat, $start, $users_per_page, $sort_name);
	foreach($data as $row)
	{
		$template->assign_block_vars('switch_users_top.users', array(
		  'ROW_CLASS'   => !($i % 2) ? 'row2' : 'row1',
			'USERNAME_URL'=> '<a class="med bold" href="'.PROFILE_URL.$row['user_id'].'" />'.$row['username'].'</a>',
			'USER_ID'			=> ($row['user_id'] > 0) ? $row['user_id'] : ANONYMOUS,
			'UPLOAD'			=> humn_size($row['u_up_total']),
			'DOWNLOAD'		=> humn_size($row['u_down_total']),
			'BONUS'				=> humn_size($row['u_up_bonus']),			
			'SEED_BONUS'	=> $row['user_points'],
			'RATIO'				=> $row['ratio'],
			'RELEASE'			=> humn_size($row['u_up_release']),

			'UPLOAD_RAW'	=> $row['u_up_total'],
			'DOWNLOAD_RAW'=> $row['u_down_total'],
			'BONUS_RAW'		=> $row['u_up_bonus'],			
			'SEED_BONUS'	=> $row['user_points'],
			'RATIO_RAW'		=> round(str_replace(',', '.', $row['ratio'])),
			'RELEASE_RAW'	=> $row['u_up_release'],
		));
		$i++;
	}
}
$template->assign_vars(array(
	'U_TOP_RELEASE_STAT'	=> '<a class="med topnav" href="'.BB_ROOT.'top.php?mode=release">'.$lang['TOP_RELEASE_STAT'].'</a>',
	'U_TOP_USERS_STAT'		=> '<a class="med topnav" href="'.BB_ROOT.'top.php?mode=users">'.$lang['TOP_USERS_STAT'].'</a>',
));

print_page('top.tpl');